#!BPY

"""
Name: 'Blender Plato Polyhedrons'
Blender: 235
Group: 'Mesh'
Tooltip: 'Make Plato Polyhedrons'
"""

#############################################################
#                                                           #
# Blender Mechanical Gears                                  #
#                                                           #
# (C) 2001 Stefano <S68> Selleri                            #
# Released under the Blender Artistic Licence (BAL)         #
# See www.blender.org                                       #
#                                                           #
#     Un ringraziamento a Martin (Theeth) che mi            #
#     ha spiegato un po' di cose.                           #
#                                                           #
#     Un altro a tHe-IcemAn per lo stimolo a                #
#     mettere tutto in matrici                              #
#                                                           #
#############################################################
# History                                                   #
# V: 0.0.0 - 2001     - THEY! This is my first Blender      #
#                       script!                             #
# V: 0.1.0 - 20-11-04 - Resuscitating this                  #
#############################################################


# Importazioni e moduli
import Blender
from Blender import *
import math
from math import *

#############################################################
# GLOBALS                                                   #
#############################################################
VERSION         ='0.1.0'

#############################################################
# INTERFACE EVENTS                                          #
#############################################################
EVENTHASH = {
    'NOEVENT': 1,
    'REDRAW': 2,
    'EXIT': 3,
    'DO': 4,
    }

DLG_OK = 500

#############################################################
# GLOBALS                                                   #
#############################################################
# Polihedron def
Tn=Draw.Create(2)
Tl=Draw.Create(1.0)

# Polihedron Rotation
Trat=Draw.Create(0)
Tran=Draw.Create(1)
Trav=Draw.Create(0.0)

# Rotation as Euler angles
Trx=Draw.Create(0.0)
Try=Draw.Create(0.0)
Trz=Draw.Create(0.0)

# MPolyhedron Definitions
VertsT = [[-0.5,+0.5,0.,0.],
          [-0.28867513459481,-0.28867513459481,0.577350269189635,0.],
          [-0.20412414523193,-0.20412414523193,-0.20412414523193,0.6123724356957]]
FacesT = [[0,0,1,2],[2,1,2,0],[1,3,3,3]]

VertsC = [[-0.5,0.5,0.5,-0.5,-0.5,0.5,0.5,-0.5],
          [-0.5,-0.5,0.5,0.5,-0.5,-0.5,0.5,0.5],
          [-0.5,-0.5,-0.5,-0.5,0.5,0.5,0.5,0.5]]
FacesC = [[0,0,0,0,1,1,2,2,3,3,4,4],
          [3,2,1,5,2,6,3,7,0,4,5,6],
          [2,1,5,4,6,5,7,6,4,7,6,7]]

VertsO = [[0.,-0.5,0.5,0.5,-0.5,0.],
          [0.,-0.5,-0.5,0.5,0.5,0.],
          [-0.70710678118655,0.,0.,0.,0.,0.70710678118655]]
FacesO = [[0,0,0,0,2,3,4,1],
          [2,3,4,1,5,5,5,5],
          [1,2,3,4,1,2,3,4]]

VertsD = [[-0.5,0.5,0.80901699437495,0.,-0.80901699437495,
           -0.80901699437495,0.,+0.80901699437495,+1.30901699437495,+1.30901699437495,
           0.80901699437495,0.,-0.80901699437495,-1.30901699437495,-1.30901699437495,
           0.,0.80901699437495,0.5,-0.5,-0.80901699437495,],
          [-0.68819096023559,-0.68819096023559,0.26286555605957,0.85065080835204,0.26286555605957,
           -1.11351636441161,-1.37638192047117,-1.11351636441161,-0.42532540417602,0.42532540417602,
           1.11351636441161,1.37638192047117,1.11351636441161,0.42532540417602,-0.42532540417602,
           -0.85065080835204,-0.26286555605957,0.68819096023559,0.68819096023559,-0.26286555605957,],
          [-1.11351636441161,-1.11351636441161,-1.11351636441161,-1.11351636441161,-1.11351636441161,
           -0.26286555605957,0.26286555605957,-0.26286555605957,0.26286555605957,-0.26286555605957,
           0.26286555605957,-0.26286555605957,0.26286555605957,-0.26286555605957,0.26286555605957,
           1.11351636441161,1.11351636441161,1.11351636441161,1.11351636441161,1.11351636441161]]
FacesD = [[0,0,0,0,0,0,1,1,1, 2, 2, 2, 3, 3, 3,4, 4, 4,16,16,16,17,17,17,18,18,18,19,19,19,15,15,15,17,17,17],
          [4,3,2,1,7,6,2,9,8, 3,11,10, 4,13,12,0, 5,14,15, 6, 7,16, 8, 9,17,10,11,18,12,13,19,14, 5,18,19,15],
          [3,2,1,7,6,5,9,8,7,11,10, 9,13,12,11,5,14,13, 6, 7, 8, 8, 9,10,10,11,12,12,13,14,14, 5, 6,19,15,16]]

VertsI = [[0.,-0.5,0.5,0.80901699437495,0.,-0.80901699437495,
           0.,0.80901699437495,0.5,-0.5,-0.80901699437495,0.],
          [0.,-0.68819096023559,-0.68819096023559,0.26286555605957,0.85065080835204,0.26286555605957,
           -0.85065080835204,-0.26286555605957,0.68819096023559,0.68819096023559,-0.26286555605957,0.],
          [-0.95105651629515,-0.42532540417602,-0.42532540417602,-0.42532540417602,-0.42532540417602,-0.42532540417602,
           0.42532540417602,0.42532540417602,0.42532540417602,0.42532540417602,0.42532540417602,0.95105651629515]]
FacesI = [[0,0,0,0,0,1,2,3,4, 5,2,3,4, 5, 1, 6, 7, 8, 9,10],
          [2,3,4,5,1,2,3,4,5, 1,7,8,9,10, 6, 7, 8, 9,10, 6],
          [1,2,3,4,5,6,7,8,9,10,6,7,8, 9,10,11,11,11,11,11]]
	  
# Rotation Matrices
Axis   = [[4,4,3,10,6],[3,6,6,15,15],[4,3,4,6,10]]
MaxAN  = 4

# Rotation Axes
AxisTT = [[0.,1.91063323624902,1.91063323624902,1.91063323624902],
          [0.95531661812451,0.95531661812451,0.95531661812451,0.0],
          [3.14159265358979,1.23095941734077,1.23095941734077,1.23095941734077]]
AxisTP = [[0.,1.57079632679490,3.66519142918809,5.75958653158129],
          [1.57079632679490,3.66519142918809,5.75958653158129,0.],
          [0.,-1.57079632679490,0.52359877559830,2.61799387799149]]

AxisCT = [[0.95531661812451,0.95531661812451,0.95531661812451,0.95531661812451,0.,0.],
          [0.78539816339745,0.78539816339745,0.78539816339745,0.78539816339745,1.57079632679490,1.57079632679490],
          [0.,1.57079632679490,1.57079632679490,0.,0.,0.]]
AxisCP = [[0.78539816339745,2.35619449019234,3.92699081698724,5.49778714378214,0.,0.],
          [0.,1.57079632679490,3.14159265358979,4.71238898038469,0.78539816339745,2.35619449019234],
          [0.,0.,1.57079632679490,0.,0.,0.]]

AxisOT = [[0.,1.57079632679490,1.57079632679490,0.,0.,0.],
          [0.7853981633974,0.7853981633974,0.7853981633974,0.7853981633974,1.57079632679490,1.57079632679490],
          [0.61547970867039,0.61547970867039,0.61547970867039,0.61547970867039,0.,0.]]
AxisOP = [[0.,0.78539816339745,2.35619449019234,0.,0.,0.],
          [0.78539816339745,2.35619449019234,3.92699081698724,5.49778714378214,0.,1.57079632679490],
          [0.,1.57079632679490,3.14159265358979,4.71238898038469,0.,0.]]

AxisDT = [[0.65235813978437,0.65235813978437,0.65235813978437,0.65235813978437,0.65235813978437,
           1.38208579601133,1.38208579601133,1.38208579601133,1.38208579601133,1.38208579601133,
           0.,0.,0.,0.,0.],
          [0.55357435889705,0.55357435889705,0.55357435889705,0.55357435889705,0.55357435889705,
           1.01722196789785,1.01722196789785,1.01722196789785,1.01722196789785,1.01722196789785,
           1.57079632679490,1.57079632679490,1.57079632679490,1.57079632679490,1.57079632679490],
          [0.,1.10714871779409,1.10714871779409,1.10714871779409,1.10714871779409,1.10714871779409,
           0.,0.,0.,0.,0.,0.,0.,0.,0.]]

AxisDP = [[-1.57079632679490,-0.31415926535898,0.94247779607694,2.19911485751286,3.45575191894877,
           -1.57079632679490,-0.31415926535898,0.94247779607694,2.19911485751286,3.45575191894877,
           0.,0.,0.,0.,0.],
          [1.57079632679490,2.82743338823081,4.08407044966673,5.34070751110265,6.59734457253857,
           -1.57079632679490,-0.31415926535898,0.94247779607694,2.19911485751286,3.45575191894877,
           -1.25663706143592,0.,1.25663706143592,2.51327412287183,3.76991118430775],
          [0.,1.57079632679490,2.82743338823081,4.08407044966673,5.34070751110265,6.59734457253857,
           0.,0.,0.,0.,0.,0.,0.,0.,0.]]

AxisIT = [[0.,1.10714871779409,1.10714871779409,1.10714871779409,1.10714871779409,1.10714871779409,
           0.,0.,0.,0.,0.,0.,0.,0.,0.],
          [0.55357435889705,0.55357435889705,0.55357435889705,0.55357435889705,0.55357435889705,
           1.01722196789785,1.01722196789785,1.01722196789785,1.01722196789785,1.01722196789785,
           1.57079632679490,1.57079632679490,1.57079632679490,1.57079632679490,1.57079632679490],
          [0.65235813978431,0.65235813978431,0.65235813978431,0.65235813978431,0.65235813978431,
           1.38208579601134,1.38208579601134,1.38208579601134,1.38208579601134,1.38208579601134,
           0.,0.,0.,0.,0.]]
AxisIP = [[0.,-1.57079632679490,-0.31415926535898,0.94247779607694,2.19911485751286,3.45575191894877,
           0.,0.,0.,0.,0.,0.,0.,0.,0.],
          [-1.57079632679490,-0.31415926535898,0.94247779607694,2.19911485751286,3.45575191894877,
           1.57079632679490,2.82743338823081,4.08407044966673,5.34070751110265,6.59734457253857,
           -1.25663706143592,0.,1.25663706143592,2.51327412287183,3.76991118430775],
          [1.57079632679490,2.82743338823081,4.08407044966673,5.34070751110265,6.59734457253857,
           1.57079632679490,2.82743338823081,4.08407044966673,5.34070751110265,6.59734457253857,
           0.,0.,0.,0.,0.]]

#############################################################
# DRAWS IT!                                                 #
#############################################################
def polyhedron(n,l,rx,ry,rz):
    me = NMesh.GetRaw()
    nverts = 0
    
    # Create it
    if (n==1):
        nv = 4
        nf = 4
        setpoly(me,nv,nf,VertsT,FacesT)
        theta = AxisTT[Trat.val][Tran.val-1]
        phi   = AxisTP[Trat.val][Tran.val-1]
        
    if (n==2):
        nv=8
        nf=12
        setpoly(me,nv,nf,VertsC,FacesC)
        theta = AxisCT[Trat.val][Tran.val-1]
        phi   = AxisCP[Trat.val][Tran.val-1]
        
    if (n==3):
        nv=6
        nf=8
        setpoly(me,nv,nf,VertsO,FacesO)
        theta = AxisOT[Trat.val][Tran.val-1]
        phi   = AxisOP[Trat.val][Tran.val-1]
        
    if (n==4):
        nv=20
        nf=36
        setpoly(me,nv,nf,VertsD,FacesD)
        theta = AxisDT[Trat.val][Tran.val-1]
        phi   = AxisDP[Trat.val][Tran.val-1]
        
    if (n==5):
        nv=12
        nf=20
        setpoly(me,nv,nf,VertsI,FacesI)
        theta = AxisIT[Trat.val][Tran.val-1]
        phi   = AxisIP[Trat.val][Tran.val-1]
        
    # Rotate it
    alpha = Trav.val*3.14159265358979/180
    
    ct    = cos(theta)
    st    = sin(theta)

    cp    = cos(phi)
    sp    = sin(phi)

    ca    = cos(alpha)
    sa    = sin(alpha)

    for i in range(0,nv):
        x1a    = me.verts[i].co[0]
        x2a    = me.verts[i].co[1]
        x3a    = me.verts[i].co[2]

        # Sets z axis along rotation axis
        x1b = x1a*ct*cp+x2a*ct*sp-x3a*st
        x2b = -x1a*sp+x2a*cp
        x3b = x1a*st*cp+x2a*st*sp+x3a*ct 
        # Rotates!
        x1c = x1b*ca-x2b*sa
        x2c = x1b*sa+x2b*ca
        x3c =               x3b
        # Sets z axis back in placez
        me.verts[i].co[0] = x1c*ct*cp-x2c*sp+x3c*st*cp
        me.verts[i].co[1] = x1c*ct*sp+x2c*cp+x3c*st*sp
        me.verts[i].co[2] = -x1c*st         +x3c*ct  

    obj = NMesh.PutRaw(me)

    # Resize
    obj.SizeX=l
    obj.SizeY=l
    obj.SizeZ=l

    # Rotates in Blender Euler system
    obj.RotX=rx*3.14159265358979/180
    obj.RotY=ry*3.14159265358979/180
    obj.RotZ=rz*3.14159265358979/180
    
    Blender.Redraw()

#############################################################
# Graphics                                                  #
#############################################################
def draw():
    global EVENTHASH
    global Tn,Tl,Trat,Tran,Trav,Trx,Try,Trz,MaxAN

    #############################################################
    # Backgrounds                                               #
    #############################################################

    BGL.glClearColor(0.5, 0.5, 0.5, 0.0)
    BGL.glClear(BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0, 0, 0) 			# Black
    BGL.glRectf(2, 2, 482, 520)
    BGL.glColor3f(0.48, 0.4, 0.57) 		# Light Purple
    BGL.glRectf(4, 479, 480, 510)
    BGL.glRectf(4, 34, 480, 450)
    BGL.glColor3f(0.3, 0.27, 0.35) 		# Dark purple
    BGL.glRectf(4, 451,480, 478)
    BGL.glRectf(4, 4, 480, 33)

    #############################################################
    # Common Header                                             #
    #############################################################

    BGL.glColor3f(0.9, 0.8, 1)
    BGL.glRasterPos2d(10, 500)
    Draw.Text("Blender Plato Polyhedrons v. "+VERSION)
    BGL.glRasterPos2d(10, 484)
    Draw.Text("(C) Nov 2004 Stefano Selleri <a.k.a. S68>")
    Draw.Button("Exit", EVENTHASH['EXIT'], 407, 482, 70, 24)
 
        
    Draw.Button("GENERATE", EVENTHASH['DO'], 7, 7, 470, 24)
    BGL.glColor3f(0.9, 0.9, 0.9)

    BGL.glRasterPos2d(8, 425)
    Draw.Text("Basics:")
    Tn=Draw.Menu("Polyhedron type  : %t|Tetrahedron %x1|Exahedron (Cube ;) %x2|Octahedron %x3|Dodecahedron %x4|Icosahedron %x5",
                   EVENTHASH['REDRAW'], 20, 400, 340, 18,Tn.val, 
                 "Polyhedron type!")
    Tl=Draw.Slider("Polyhedron side  : ", EVENTHASH['NOEVENT'],
                   20, 380, 340, 18, Tl.val, 0.0, 10.0,0,
                   "Side of a edge, in Blender Units")
    #
    BGL.glRasterPos2d(8, 345)
    Draw.Text("Rotation around a symmetry axis:")
    Trat=Draw.Menu("Axis Type      : %t|Vertex axis %x0|Edge axis %x1|Face Axis %x2",
                   EVENTHASH['REDRAW'], 20, 320, 340, 18, Trat.val, 
                   "The axis passes through poly center and...")
    Tran=Draw.Slider("Axis Number    : ",
                     EVENTHASH['NOEVENT'], 20, 300, 340, 18, Tran.val, 1, MaxAN,0,
                     "Axis number within its family")
    Trav=Draw.Slider("Rotation Angle : ",
                     EVENTHASH['NOEVENT'], 20, 280, 340, 18, Trav.val, 0.0, 360.0,0,
                     "Rotation, in degrees, around the axis")
    #
    BGL.glRasterPos2d(8, 245)
    Draw.Text("Additional rotation (Blender standard):")
    Trx=Draw.Slider("Axis X rotation : ", EVENTHASH['NOEVENT'],
                    20, 220, 340, 18, Trx.val, 0.0, 180.0)
    Try=Draw.Slider("Axis Y rotation : ", EVENTHASH['NOEVENT'],
                    20, 200, 340, 18, Try.val, 0.0, 360.0)
    Trz=Draw.Slider("Axis Z rotation : ", EVENTHASH['NOEVENT'],
                    20, 180, 340, 18, Trz.val, 0.0, 360.0)
  

def setpoly(me,nv,nf,Verts,Faces):
    for i in range (0,nv):
        v = NMesh.Vert(Verts[0][i],Verts[1][i],Verts[2][i])
        me.verts.append(v)
        
    for i in range (0,nf):
        f=NMesh.Face()
        f.v.append(me.verts[Faces[0][i]])  
        f.v.append(me.verts[Faces[1][i]])  
        f.v.append(me.verts[Faces[2][i]])
        f.smooth=0
        me.faces.append(f)
        
def event(evt, val):	
    if (evt== Draw.QKEY and not val):
        Draw.Exit()

def bevent(evt):
    global EVENTHASH
    global Tn,Tl,Trat,Tran,Trav,Trx,Try,Trz,MaxAN

    if   (evt== EVENTHASH['EXIT']):
        Draw.Exit()
    elif (evt== EVENTHASH['REDRAW']):
        MaxAN=Axis[Trat.val][Tn.val-1]
        if (Tran.val>MaxAN):
            Tran.val=MaxAN
        Blender.Redraw()
    elif (evt== EVENTHASH['DO']):
        polyhedron(Tn.val,Tl.val,Trx.val,Try.val,Trz.val)
        Blender.Redraw()

Draw.Register(draw, event, bevent)
